#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

const ll INF = 1e18, md = 1e9, MAXN = 30;

struct Point{
    int x, y;
};

struct tre{
    Point A, B, C;
};

vector<tre> treygol(MAXN);

long double distPoint(Point A, Point B)
{
    return sqrt((A.x - B.x) * (A.x - B.x) + (A.y - B.y) * (A.y - B.y));
}

long double kv(long double a)
{
    return a * a;
}

long double gip(int ind)
{
    return distPoint(treygol[ind].A, treygol[ind].C);
}

long double kat(int ind)
{
    return distPoint(treygol[ind].A, treygol[ind].B);
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);

    int t;
    cin >> t;
    int n;
    cin >> n;
    for (int i = 0; i < n; ++i)
    {
        cin >> treygol[i].A.x >> treygol[i].A.y >> treygol[i].B.x >> treygol[i].B.y >> treygol[i].C.x >> treygol[i].C.y;
    }
    vector<pair<pair<int, int>, pair<int, int>>> ans;
    for (int i = 0; i < n; ++i)
    {
        for (int j = 0; j < n; ++j)
        {
            for (int g = 0; g < n; ++g)
            {
                for (int h = 0; h < n; ++h)
                {
                    set<int> s;
                    s.insert(i);
                    s.insert(j);
                    s.insert(g);
                    s.insert(h);
                    if (s.size() == 4)
                    {
                        if (kv(gip(h) + kat(g)) == kv(kat(i) + gip(g)) + kv(kat(i) + kat(h)))
                        {
                            ans.push_back({{i, j}, {g, h}});
                        }
                    }
                }
            }
        }
    }
    cout << ans.size() << '\n';
    for (int i = 0; i < ans.size(); ++i)
    {
        cout << ans[i].first.first + 1 << ' ' << ans[i].first.second + 1 << ' ' << ans[i].second.first + 1 << ' ' << ans[i].second.second + 1 << '\n';
    }
    return 0;
}
