#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

const ll INF = 1e18, md = 1e9, MAXN = 1e5;

vector<int> a(MAXN), b(MAXN), c(MAXN);

bool check(int l1, int l2, int k)
{
    for (int i = 0; i < k; ++i)
    {
        c[i] = a[l1] + b[l2];
        l1++;
        l2++;
    }
    for (int i = 0; i < k; ++i)
    {
        if (c[i] != c[k - i - 1]) return false;
    }
    return true;
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);

    int n, m;
    cin >> n >> m;
    for (int i = 0; i < n; ++i)
    {
        cin >> a[i];
    }
    for (int i = 0; i < m; ++i)
    {
        cin >> b[i];
    }
    int l = 0, r = min(m, n) + 1;
    while (r - l > 1)
    {
        bool f = false;
        int mid = (l + r) / 2;
        for (int i = 0; i < n - mid; ++i)
        {
            for (int j = 0; j < m - mid; ++j)
            {
                if (check(i, j, mid))
                {
                    f = true;
                    break;
                }
            }
            if (f) break;
        }
        if (f) l = mid;
        else r = mid;
    }
    cout << l;
    return 0;
}
