#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

const ll INF = 1e18, md = 1e9, MAXN = 1e5;

vector<int> a(MAXN), b(MAXN), c(MAXN);

bool check(int l1, int l2, int k)
{
    for (int i = 0; i < k; ++i)
    {
        c[i] = a[l1] + b[l2];
        l1++;
        l2++;
    }
    for (int i = 0; i < k; ++i)
    {
        if (c[i] != c[k - i - 1]) return false;
    }
    return true;
}

struct Point{
    ll x, y;
};

struct tre{
    Point A, B, C;
};

vector<tre> treygol(MAXN);

long double dist(Point A, Point B)
{
    return sqrt((A.x - B.x) * (A.x - B.x) + (A.y - B.y) * (A.y - B.y));
}

long double kat(int ind)
{
    return dist(treygol[ind].A, treygol[ind].B);
}

long double gip(int ind)
{
    return dist(treygol[ind].A, treygol[ind].C);
}

long double kat1(int ind)
{
    return dist(treygol[ind].C, treygol[ind].B);
}

long double kv(long double a)
{
    return a * a;
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);

    int n, m, mx = -1;
    cin >> n >> m;
    if (n <= 300 && m <= 300)
    {
        for (int i = 0; i < n; ++i)
        {
            cin >> a[i];
        }
        for (int i = 0; i < m; ++i)
        {
            cin >> b[i];
        }
        for (int mid = min(m, n); mid >= 1; --mid)
        {
            for (int i = 0; i <= n - mid; ++i)
            {
                for (int j = 0; j <= m - mid; ++j)
                {
                    if (check(i, j, mid))
                    {
                        cout << mid;
                        return 0;
                    }
                }
            }
        }
    }
    for (int i = 0; i < n; ++i) cin >> a[i];
    for (int i = 0; i < m; ++i) cin >> b[i];
    for (int cen = 0; cen < n; ++cen)
    {
        int yk = 0;
        while (yk <= min(cen, n - cen - 1) && a[cen + yk] == a[cen - yk])
        {
            yk++;
        }
        mx = max(mx, 2 * (yk - 1) + 1);
    }
    for (int cen = 1; cen < n; ++cen)
    {
        int yk = 1;
        while (yk <= min(cen, n - cen) && a[cen + yk - 1] == a[cen - yk])
        {
            yk++;
        }
        mx = max(mx, (yk - 1) * 2);
    }
    cout << mx;
    return 0;
}
