#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

const int MAXN = 1e5, INF = 1e9;

vector<int> obxod;
vector<pair<int, int>> g[MAXN];

void dfs(int v)
{
    for (auto i : g[v])
    {
        dfs(i.first);
    }
    obxod.push_back(v);
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);

    int n, k;
    cin >> n >> k;
    vector<pair<int, int>> p(n);
    for (int i = 1; i < n; ++i)
    {
        cin >> p[i].first >> p[i].second;
        p[i].first--;
        g[p[i].first].push_back({i, p[i].second});
    }
    dfs(0);
    vector<int> used(n);
    vector<int> dp(n);
    for (int i = 0; i < obxod.size(); ++i)
    {
        for (auto a : g[obxod[i]])
        {
            if (used[a.first] < k && used[obxod[i]] < k)
            {
                used[a.first]++;
                used[obxod[i]]++;
                dp[obxod[i]] += dp[a.first] + 1;
            }
            else
            {
                dp[obxod[i]] += dp[a.first];
            }
        }
    }
    cout << dp[0] << ' ' << 0;
    return 0;
}
