#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

const ll INF = 1e18, md = 1e9, MAXN = 30;

struct Point{
    ll x, y;
};

struct tre{
    Point A, B, C;
};

vector<tre> treygol(MAXN);

long double dist(Point A, Point B)
{
    return sqrt((A.x - B.x) * (A.x - B.x) + (A.y - B.y) * (A.y - B.y));
}

long double kat(int ind)
{
    return dist(treygol[ind].A, treygol[ind].B);
}

long double gip(int ind)
{
    return dist(treygol[ind].A, treygol[ind].C);
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);

    int t;
    cin >> t;
    int n;
    cin >> n;
    for (int i = 0; i < n; ++i)
    {
        cin >> treygol[i].A.x >> treygol[i].A.y >> treygol[i].B.x >> treygol[i].B.y >> treygol[i].C.x >> treygol[i].C.y;
        if (dist(treygol[i].A, treygol[i].B) > dist(treygol[i].A, treygol[i].C))
        {
            swap(treygol[i].B, treygol[i].C);
        }
    }
    set<pair<pair<ll, ll>, pair<ll, ll>>> ans;
    for (int i = 0; i < n; ++i)
    {
        for (int j = 0; j < n; ++j)
        {
            for (int g = 0; g < n; ++g)
            {
                for (int h = 0; h < n; ++h)
                {
                    if (i != j && i != g && i != h && j != g && j != h && g != h)
                    {
                        if (kat(i) == kat(j) && kat(i) == kat(g) && kat(i) == kat(h) || gip(j) == kat(h) && kat(j) == kat(g) && gip(i) == kat(j))
                        {
                            set<int> s;
                            s.insert(i + 1);
                            s.insert(j + 1);
                            s.insert(g + 1);
                            s.insert(h + 1);
                            auto it = s.begin();
                            int m1 = *it;
                            ++it;
                            int m2 = *it;
                            ++it;
                            int m3 = *it;
                            ++it;
                            int m4 = *it;
                            ans.insert({{m1, m2}, {m3, m4}});
                        }
                    }
                }
            }
        }
    }
    cout << ans.size() << '\n';
    for (auto i : ans)
    {
        cout << i.first.first << ' ' << i.first.second << ' ' << i.second.first << ' ' << i.second.second << '\n';
    }
    return 0;
}
