#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

const ll INF = 1e18, md = 1e9, MAXN = 30;

struct Point{
    int x, y;
};

struct tre{
    Point A, B, C;
};

vector<tre> treygol(MAXN);

long double distPoint(Point A, Point B)
{
    return sqrt((A.x - B.x) * (A.x - B.x) + (A.y - B.y) * (A.y - B.y));
}

long double kv(long double a)
{
    return a * a;
}

long double gip(int ind)
{
    return distPoint(treygol[ind].A, treygol[ind].C);
}

long double kat(int ind)
{
    return distPoint(treygol[ind].A, treygol[ind].B);
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);

    int t;
    cin >> t;
    int n;
    cin >> n;
    for (int i = 0; i < n; ++i)
    {
        cin >> treygol[i].A.x >> treygol[i].A.y >> treygol[i].B.x >> treygol[i].B.y >> treygol[i].C.x >> treygol[i].C.y;
    }
    set<pair<pair<int, int>, pair<int, int>>> ans;
    for (int i = 0; i < n; ++i)
    {
        for (int j = 0; j < n; ++j)
        {
            for (int g = 0; g < n; ++g)
            {
                for (int h = 0; h < n; ++h)
                {
                    if (i != j && i != g && i != h && j != g && j != h && g != h)
                    {
                        int razx = treygol[i].A.x - treygol[j].A.x;
                        int razy = treygol[i].A.y - treygol[j].A.y;
                        tre new_j = {treygol[j].A.x + razx, treygol[j].A.y + razy, treygol[j].B.x + razx, treygol[j].B.y + razy, treygol[j].C.x + razx, treygol[j].C.y + razy};
                        razx = treygol[i].A.x - treygol[h].B.x;
                        razy = treygol[i].A.y - treygol[h].B.y;
                        tre new_h = {treygol[h].A.x + razx, treygol[h].A.y + razy, treygol[h].B.x + razx, treygol[h].B.y + razy, treygol[h].C.x + razx, treygol[h].C.y + razy};
                        razx = treygol[i].C.x - treygol[g].C.x;
                        razy = treygol[i].C.y - treygol[g].C.y;
                        tre new_g ={treygol[g].A.x + razx, treygol[g].A.y + razy, treygol[g].B.x + razx, treygol[g].B.y + razy, treygol[g].C.x + razx, treygol[g].C.y + razy};
                        if (new_g.C.x == new_j.B.x && new_g.B.x == new_h.C.x && new_g.B.x == new_j.C.x)
                        {
                            set<int> s;
                            s.insert(i + 1);
                            s.insert(j + 1);
                            s.insert(g + 1);
                            s.insert(h + 1);
                            auto it = s.begin();
                            int mn1 = *it;
                            ++it;
                            int mn2 = *it;
                            ++it;
                            int mn3 = *it;
                            ++it;
                            int mn4 = *it;
                            ans.insert({{mn1, mn2}, {mn3, mn4}});
                        }
                    }
                }
            }
        }
    }
    cout << ans.size() << '\n';
    for (auto i : ans)
    {
        cout << i.first.first << ' ' << i.first.second << ' ' << i.second.first << ' ' << i.second.second << '\n';
    }
    return 0;
}
