#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

ll gcd(ll a, ll b)
{
    if (a == 0) return b;
    else return gcd(b % a, a);
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);

    ld EPS = 1e-10;
    int n, q;
    cin >> n >> q;
    vector<int> a(n), b(n), c(q);
    for (int i = 0; i < n; ++i)
    {
        cin >> a[i];
    }
    for (int i = 0; i < n; ++i)
    {
        cin >> b[i];
    }
    sort(b.begin(), b.end());
    vector<int> yk(n);
    for (int zap = 0; zap < q; ++zap)
    {
        cin >> c[zap];
        ld l = -1, r = 1e6 + 1;
        while (true)
        {
            ld m = (l + r) / 2;
            int cnt = 0;
            for (int i = 0; i < n; ++i)
            {
                int left = -1, right = n;
                while (right - left > 1)
                {
                    int mid = (left + right) / 2;
                    if ((ld)a[i] / b[mid] <= m)
                    {
                        right = mid;
                    }
                    else
                    {
                        left = mid;
                    }
                }
                yk[i] = right;
                cnt += n - right;
            }
            if (cnt > c[zap])
            {
                r = m;
            }
            else if (cnt < c[zap])
            {
                l = m;
            }
            else
            {
                ld mx = -1;
                ll ans_a, ans_b;
                for (int i = 0; i < n; ++i)
                {
                    if (yk[i] < n && mx < (ld)a[i] / b[yk[i]])
                    {
                        mx = (ld)a[i] / b[yk[i]];
                        ans_a = a[i];
                        ans_b = b[yk[i]];
                    }
                }
                cout << ans_a / gcd(ans_a, ans_b) << ' ' << ans_b / gcd(ans_a, ans_b) << '\n';
                break;
            }
            if (r - l < EPS)
            {
                c[zap]++;
            }
        }
    }
    return 0;
}
